#!/usr/bin/env python
import simpleSVG, sys,math,re
from optparse import OptionParser
usage="usage: %prog expname [options]"
parser = OptionParser(usage=usage, version="%prog 0.1")
parser.add_option("--fmin", dest="fmin",type="float",help="min val f on axis",default=0.)
parser.add_option("--fmax", dest="fmax",type="float",help="max val f on axis",default=800.)
parser.add_option("--dtic", dest="dtic",type="float",help=" T ticks",default=100.)
parser.add_option("--outdir", dest="outdir",type="str",help=" directory for svg plots",default='.')
(opt, args) = parser.parse_args()
name=args[0]
colors=['blue','red','darkgreen']
######################
def ripout(thefile,tag,skip,num,pos):
    l=len(tag)
    vals=[]
    lines=thefile.split('\n')
    foundit=False
    for i in range(len(lines)):
        if re.search(tag,lines[i]):
            foundit=True
            break
    if not foundit:
        print("ripout fail, could not find tag: ",tag)
        sys.exit()
    for j in range(num):
        v=lines[i+skip+j].split()
        try:
            vals.append(float(v[pos]))
        except:
            print("ripout fail:",lines[i+skip+j],v,v[pos])
    if num==1:
        return vals[0]
    else:
        return vals
######################
outfile=opt.outdir+'/'+name+'_flux.svg'
b=simpleSVG.svg_class(fname=outfile)
b.scale(xmin=opt.fmin,xmax=opt.fmax,ymin=0,ymax=50,leftmarg=85,rightmarg=15)
b.group(fill="black") #otherwise fonts are hollow
b.xaxis(form="%4d",dx=opt.dtic)
b.yaxis(form="%2d")
hroutfile=opt.outdir+'/'+name+'_hr.svg'
hr=simpleSVG.svg_class(fname=hroutfile)
hr.scale(xmin=-5.,xmax=5.,ymin=0,ymax=50,leftmarg=85,rightmarg=15)
hr.group(fill="black") #otherwise fonts are hollow
hr.xaxis(form="%3d",dx=1.)
hr.yaxis(form="%2d")
nfile=0
toff=.4j
infilename='exp/'+name+'.lev'
inf=open(infilename,'r')
print(infilename)
all=inf.readlines()
hash={}
while 1:
    if all[0][0]!='#': break
    header=all.pop(0)
    header=header.strip()
    header=header.replace('#','')
    header=header.replace('{','')
    header=header.replace('}','')
    hh=header.split(',')
    for h in hh:
        k,v=h.split(':')
        try:
            hash[k.strip()]=float(v.strip())
        except:
            hash[k.strip()]=v.strip()
print(hash)
zf=[]
hf=[]
for line in all:
    v=line.split()
    hf.append(float(v[5]))
    zf.append(float(v[1])/1000.)
hf[-1]=hash['sensflux']
color=colors[nfile]
crmfilename='exp/'+name+'.out'
crmfile=open(crmfilename,'r')
allcrm=crmfile.read()
layfilename='exp/'+name+'.lay'
layfile=open(layfilename,'r')
alllay=layfile.read()
layers=len(hf)-1
zl=ripout(alllay,'^#',3,layers,1)
netheatingrate=ripout(allcrm,'^Heating rates',3,layers,4)
lwheatingrate=ripout(allcrm,'^Heating rates',3,layers,3)
swheatingrate=ripout(allcrm,'^Heating rates',3,layers,2)
conheatingrate=[-x for x in netheatingrate]
#print "nethr:", zip(netheatingrate,zl)
xl=None
zl=[x/1000. for x in zl]
hr.group(stroke='blue',fill='blue')
for x,y in zip(conheatingrate,zl):
    if xl: hr.line(xl,yl,x,y)
    hr.circle(x,y,3)
    xl=x
    yl=y
hr.line(1.5,25.,2.5,25.)
hr.text(2.7,25.,0,'convective',font_size='14pt',stroke_width="0")
hr.group()
xl=None
hr.group(stroke='red',fill='red')
for x,y in zip(lwheatingrate,zl):
    if xl: hr.line(xl,yl,x,y)
    hr.circle(x,y,3)
    xl=x
    yl=y
hr.line(1.5,20.,2.5,20.)
hr.text(2.7,20.,0,'longwave',font_size='14pt',stroke_width="0")
hr.group()
xl=None
hr.group(stroke='darkgreen',fill='darkgreen')
for x,y in zip(swheatingrate,zl):
    if xl: hr.line(xl,yl,x,y)
    hr.circle(x,y,3)
    xl=x
    yl=y
hr.line(1.5,15.,2.5,15.)
hr.text(2.7,15.,0,'shortwave',font_size='14pt',stroke_width="0")
hr.group()
#z.append(0.)
#hf.append(hash['sensflux'])
lwfluxup=ripout(allcrm,'^LW Fluxes',3,layers+1,3)
lwfluxdn=ripout(allcrm,'^LW Fluxes',3,layers+1,2)
swfluxup=ripout(allcrm,'^SW Fluxes',3,layers+1,3)
swfluxdn=ripout(allcrm,'^SW Fluxes',3,layers+1,2)
xl=None
b.group(stroke='blue',fill='blue')
for x,y in zip(hf,zf):
    if xl: b.line(xl,yl,x,y)
    b.arrow(x,y,x,y+2,10,stroke_width=3)
    xl=x
    yl=y
b.line(500.,40.,600.,40.)
b.text(620.,40.,0,'convective',font_size='14pt',stroke_width="0")
b.group()
xl=None
b.group(stroke='red',fill='red')
for x,y in zip(lwfluxdn,zf):
    if xl: b.line(xl,yl,x,y)
    b.arrow(x,y,x,y-2,10,stroke_width=3)
    xl=x
    yl=y
b.line(500.,30.,600.,30.)
b.text(620.,30.,0,'longwave',font_size='14pt',stroke_width="0")
b.group()
xl=None
b.group(stroke='red',fill='red')
for x,y in zip(lwfluxup,zf):
    if xl: b.line(xl,yl,x,y)
    b.arrow(x,y,x,y+2,10,stroke_width=3)
    xl=x
    yl=y
b.group()
xl=None
b.group(stroke='darkgreen',fill='darkgreen')
for x,y in zip(swfluxdn,zf):
    if xl: b.line(xl,yl,x,y)
    b.arrow(x,y,x,y-2,10,stroke_width=3)
    xl=x
    yl=y
b.line(500.,20.,600.,20.)
b.text(620.,20.,0,'shortwave',font_size='14pt',stroke_width="0")
b.group()
xl=None
b.group(stroke='darkgreen',fill='darkgreen')
for x,y in zip(swfluxup,zf):
    if xl: b.line(xl,yl,x,y)
    b.arrow(x,y,x,y+2,10,stroke_width=3)
    xl=x
    yl=y
b.group()
#if nfile==0: tbase=hash['surairt']
#deltat=hash['surairt']-tbase
#if nfile>0:
#       legend=", surface air &#916;T=%5.3f K" % (deltat)
#else:
#       legend=", surface air T=%7.3f K" % (hash['surairt'])
#hr.text(.50j,toff, 0,name,font_size='14pt',stroke_width='0pt',text_anchor='end')
#b.text(.50j,toff, 0,name,font_size='14pt',stroke_width='0pt',text_anchor='end')
#b.text(.50j,toff, 0,legend,font_size='14pt',stroke_width='0pt')
b.group()
nfile+=1
toff+=.1j
inf.close()
############
b.group(stroke_width='0pt')
b.text(.40j,.97j, 0,'flux density (W m<tspan dy="-4">-2</tspan><tspan dy="4">)</tspan>',font_size='14pt',fill='black')
b.text(.03j,.47j, 0,'z (km)',font_size='14pt',fill='black')
#b.text(.02j,.05j, 0,'radiative-convective equilibrium with crm-2.1.2-ccm-3.6',font_size='14pt',fill='black')
b.text(.1j,.05j, 0,'radiative-convective equilibrium, model run: '+name,font_size='13pt',fill='black')
b.close()
hr.group(stroke_width='0pt')
hr.text(.03j,.47j, 0,'z (km)',font_size='14pt',fill='black')
hr.text(.40j,.97j, 0,'heating rate (K day<tspan dy="-4">-1</tspan><tspan dy="4">)</tspan>',font_size='14pt',fill='black')
#hr.text(.02j,.05j, 0,'radiative-convective equilibrium with crm-2.1.2-ccm-3.6',font_size='14pt',fill='black')
hr.text(.1j,.05j, 0,'radiative-convective equilibrium, model run: '+name,font_size='13pt',fill='black')
hr.close()
