#!/usr/bin/env python
# v0.2 5 March 2010
import simpleSVG, sys,math
from optparse import OptionParser
usage="usage: %prog expname [options]"
parser = OptionParser(usage=usage, version="%prog 0.1")
parser.add_option("--tmin", dest="tmin",type="float",help="min val T on axis",default=210.)
parser.add_option("--tmax", dest="tmax",type="float",help="max val T on axis",default=310.)
parser.add_option("--dtic", dest="dtic",type="float",help=" T ticks",default=10.)
parser.add_option("--outdir", dest="outdir",type="str",help=" directory for svg plots",default='.')
parser.add_option("--indir", dest="indir",type="str",help=" directory of radcon output ",default='exp')
parser.add_option("--notext", dest="notext",action="store_true",help=" suppress tex",default=False)
(opt, args) = parser.parse_args()
expnames=args
outfile=opt.outdir+'/'+"_".join(expnames)+'.svg'
mxoutfile=opt.outdir+'/'+"_".join(expnames)+'_mx.svg'
colors=['blue','red','darkgreen','purple']*2
b=simpleSVG.svg_class(fname=outfile)
b.scale(xmin=opt.tmin,xmax=opt.tmax,ymin=0,ymax=50,leftmarg=85,rightmarg=15)
b.group(fill="black") #otherwise fonts are hollow
b.xaxis(form="%3d",dx=opt.dtic)
b.yaxis(form="%2d")
mx=simpleSVG.svg_class(fname=mxoutfile)
mx.scale(xmin=-6.,xmax=-1.,ymin=0,ymax=50,leftmarg=85,rightmarg=15)
mx.group(fill="black") #otherwise fonts are hollow
mx.xaxis(form="%3d",dx=1.)
mx.yaxis(form="%2d")
nfile=0
toff=.4j
for name in expnames:
    infilename=opt.indir+'/'+name+'.lay'
    inf=open(infilename,'r')
    print(infilename)
    all=inf.readlines()
    hash={}
    while 1:
        if all[0][0]!='#': break
        header=all.pop(0)
        header=header.strip()
        header=header.replace('#','')
        header=header.replace('{','')
        header=header.replace('}','')
        hh=header.split(',')
        for h in hh:
            k,v=h.split(':')
            try:
                hash[k.strip()]=float(v.strip())
            except:
                hash[k.strip()]=v.strip()
    print(hash)
    t=[]
    z=[]
    m=[]
    for line in all:
        v=line.split()
        t.append(float(v[3]))
        m.append(math.log10(float(v[4])))
        z.append(float(v[1])/1000.)
    color=colors[nfile]
    xl=None
    mx.group(stroke=color,fill=color)
    for x,y in zip(m,z):
        if xl: mx.line(xl,yl,x,y)
        xl=x
        yl=y
    z.append(0.)
    t.append(hash['surairt'])
    xl=None
    b.group(stroke=color,fill=color)
    for x,y in zip(t,z):
        if xl: b.line(xl,yl,x,y)
        xl=x
        yl=y
    b.line(hash['skntem'],0.,hash['skntem'],-1.)
    if nfile==0: tbase=hash['surairt']
    deltat=hash['surairt']-tbase
    if nfile>0:
        legend=", surface air &#916;T=%5.3f K" % (deltat)
    else:
        legend=", surface air T=%7.3f K" % (hash['surairt'])
    if not opt.notext:
        mx.line(.50j,toff,.60j,toff)
        mx.text(.62j,toff, 0,name,font_size='14pt',stroke_width='0pt',text_anchor='start')
        b.text(.50j,toff, 0,name,font_size='14pt',stroke_width='0pt',text_anchor='end')
        b.text(.50j,toff, 0,legend,font_size='14pt',stroke_width='0pt')
    b.group()
    nfile+=1
    toff+=.1j
    inf.close()
b.group(stroke_width='0pt')
mx.group(stroke_width='0pt')
b.text(.50j,.97j, 0,'T (K)',font_size='14pt',fill='black')
mx.text(.45j,.97j, 0,'log(mixing ratio)',font_size='14pt',fill='black')
b.text(.03j,.47j, 0,'z (km)',font_size='14pt',fill='black')
mx.text(.03j,.47j, 0,'z (km)',font_size='14pt',fill='black')
b.text(.02j,.05j, 0,'radiative-convective equilibrium with crm-2.1.2-ccm-3.6',font_size='13pt',fill='black')
mx.text(.02j,.05j, 0,'radiative-convective equilibrium with crm-2.1.2-ccm-3.6',font_size='13pt',fill='black')
b.close()
mx.close()
